datablock ItemData(MlbxNoteItem)
{
	shapeFile = "./Note.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;
	
	uiName = "Mailbox Note";
	iconName = "./Note";
	doColorShift = false;
	
	image = MlbxNoteImage;
	canDrop = true;
	
	mlbx_GUI = "createNoteGUI";
	isMlbxItem = true;
};

datablock ShapeBaseImageData(MlbxNoteImage)
{
	shapeFile = "./Note.dts";
	emap = false;
	mountPoint = 0;
	offset = "0.0 0.2 0.0";
	eyeOffset = 0;
	rotation = eulerToMatrix("0 0 0");
	
	className = "WeaponImage";
	item = MlbxNoteItem;
	projectile = mlbxProjectile;
	projectileType = Projectile;
	
	armReady = true;
	doColorShift = false;
	
	stateName[0]				= "Activate";
	stateTimeoutValue[0]	    = 0.2;
	stateTransitionOnTimeout[0] = "Ready";
	stateScript[0]				= "onRelease";

	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;

	stateName[2]				= "Fire";
	stateTransitionOnTimeout[2] = "Hold";
	stateTimeoutValue[2]	    = 0.01;
	stateFire[2]				= true;
	stateAllowImageChange[2]    = false;
	stateSequence[2]		    = "Fire";
	stateScript[2]				= "onFire";
	stateWaitForTimeout[2]	    = true;

	stateName[3]				  = "Hold";
	stateTimeoutValue[3]		  = 0.01;
	stateScript[3]				  = "onHold";
	stateTransitionOnTimeout[3]	  = "Hold";
	stateTransitionOnTriggerUp[3] = "Release";

	statename[4]				= "Release";
	stateAllowImageChange[4]    = false;
	stateTimeoutValue[4]	    = 0.01;
	stateTransitionOnTimeout[4] = "Ready";
	stateScript[4]				= "onRelease";
};