function mlbx_addMailRow(%n,%data)
{
	//New?	Type	ID - Name	Date Time;
	
	%row = new GuiSwatchCtrl(%sw = "mailRow" @ %n)
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = 0 SPC %n * 24;
		extent = "546 24";
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		color = "255 255 255 150";

		new GuiBitmapCtrl(%bmp = "mlbx_mailInv_img" @ %n)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "34 0";
			extent = "24 24";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			bitmap = "add-ons/System_Mail/GUI/Images/noitem";
			wrap = "0";
			lockAspectRatio = "0";
			alignLeft = "0";
			alignTop = "0";
			overflowImage = "0";
			keepCached = "0";
			mColor = "255 255 255 255";
			mMultiply = "0";
		};
		new GuiMLTextCtrl("mlbx_mailInv_new" @ %n)
		{
			profile = "GuiMLTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "4 4";
			extent = "32 16";
			minExtent = "8 2";
			enabled = "1";
			visible = getField(%data,0);
			clipToParent = "1";
			lineSpacing = "2";
			allowColorChars = "0";
			maxChars = "-1";
			text = "<font:impact:16><color:ff0000>NEW!";
			maxBitmapHeight = "-1";
			selectable = "1";
			autoResize = "1";
		};
		new GuiTextCtrl("mlbx_mailInv_type" @ %n)
		{
			profile = "GuiTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "62 3";
			extent = "34 18";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			text = getField(%data,1);
			maxLength = "255";
		};
		new GuiTextCtrl("mlbx_mailInv_sndr" @ %n)
		{
			profile = "GuiTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "134 3";
			extent = "80 18";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			text = getField(%data,2);
			maxLength = "255";
		};
		new GuiTextCtrl("mlbx_mailInv_rcvd" @ %n)
		{
			profile = "GuiTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "314 3";
			extent = "68 18";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			text = getField(%data,3);
			maxLength = "255";
		};
		new GuiBitmapButtonCtrl("mlbx_mailInv_btnDel" @ %n)
		{
			profile = "BlockButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "444 1";
			extent = "48 20";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			command = "commandToServer(\'mlbx_Request\',\"deleteMail\"," @ %n @ ");";
			text = "Delete";
			groupNum = "-1";
			buttonType = "PushButton";
			bitmap = "base/client/ui/button1";
			lockAspectRatio = "0";
			alignLeft = "0";
			alignTop = "0";
			overflowImage = "0";
			mKeepCached = "0";
			mColor = "255 0 0 255";
		};
		new GuiBitmapButtonCtrl("mlbx_mailInv_btnView" @ %n)
		{
			profile = "BlockButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "494 1";
			extent = "48 20";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			command = "commandToServer(\'mlbx_Request\',\"viewMail\"," @ %n @ ");"; //mlbx_mailInv_new" @ %n @ ".setVisible(0);
			text = "View";
			groupNum = "-1";
			buttonType = "PushButton";
			bitmap = "base/client/ui/button1";
			lockAspectRatio = "0";
			alignLeft = "0";
			alignTop = "0";
			overflowImage = "0";
			mKeepCached = "0";
			mColor = "255 255 255 255";
		};
	};
	
	//////////////////////////////////////////////////
	
	if((mFloor(%n / 2) * 2) != %n)
		%sw.color = "210 210 210 150";
	
	switch$(getField(%data,1))
	{
		case "Note":
			%bmp.setBitmap("add-ons/System_Mail/ITEMs/Note/Note");
			
		case "Letter":
			%bmp.setBitmap("add-ons/System_Mail/ITEMs/Letter/Letter");
			
		case "Card":
			%bmp.setBitmap("add-ons/System_Mail/ITEMs/Card/Card");
			
		case "Package":
			%bmp.setBitmap("add-ons/System_Mail/ITEMs/Package/Package");
	}
	
	mlbx_mailListBG.resize(1,1,546,mClamp((%n + 1) * 24,24,1200));
	mlbx_mailListBG.add(%row);
	mlbx_mailListBG.rowCount = mClamp(mlbx_mailListBG.rowCount++,0,50);
}
