exec("add-ons/System_Mail/SCRIPTs/Client/mailObjs.cs");
exec("add-ons/System_Mail/SCRIPTs/Client/Package.cs");

new GuiControlProfile(MlbxGuiScrollProfile : GuiScrollProfile)
{
   opaque = "0";
};
if(!isObject(Mlbx_GUI))
	exec("add-ons/System_Mail/GUI/mlbx_gui.gui");


////////////////////////////////////////////////////////////////////////////////////////////////////


function CLIENTCMDmlbx_GUIUpdate(%action,%n,%data)
{
	switch$(%action)
	{
		case "openDpBx":
			mlbx_DpBxDestMenu.setSelected(0);
			mlbx_DpBxDestMenu.setText("(Choose Mail Brick Destination)");
			
			canvas.PushDialog(Mlbx_GUI);
			mlbx_DpBxDestWndw.setVisible(1);
			
		
		case "createNoteGUI":
			mlbx_writeNote.setVisible(1);
			mlbx_noteText.setText("<font:impact:24>text...");
			
			canvas.pushDialog(mlbx_GUI);
			mlbx_DpBxDestWndw.setVisible(0);
		
		
		case "createLtrGUI":
			mlbx_writeLtr.setVisible(1);
			mlbx_ltrText.setText("<font:impact:20>text...");
			mlbx_createLtrScroll.scrollToTop();
			
			canvas.pushDialog(mlbx_GUI);
			mlbx_DpBxDestWndw.setVisible(0);
		
		
		case "createCardGUI":
			mlbx_writeCard.setVisible(1);
			mlbx_cardType.setSelected(0);
			mlbx_cardType.setText("Choose Type:");
			mlbx_cardImg.setBitmap("Add-Ons/System_Mail/GUI/Cards/card0");
			
			canvas.pushDialog(mlbx_GUI);
			mlbx_DpBxDestWndw.setVisible(0);
		
		
		case "createPckgGUI":
			mlbx_createPckg.setVisible(1);
			mlbx_pckgItem.clear();
			mlbx_pckgItem.setSelected(0);
			mlbx_pckgItem.setText("Choose Inventory Item:");
			mlbx_pckgImg.setBitmap("Add-Ons/System_Mail/GUI/Images/noitem");
			mlbx_pckgImg.mColor = "255 255 255 255";
			
			canvas.pushDialog(mlbx_GUI);
			mlbx_DpBxDestWndw.setVisible(0);
	
	
		case "closeAll":
			mlbx_writeNote.setVisible(0);
			mlbx_writeLtr.setVisible(0);
			mlbx_writeCard.setVisible(0);
			mlbx_createPckg.setVisible(0);
			mlbx_mlbxInv.setVisible(0);
			mlbx_DpBxDestWndw.setVisible(0);
			
			mlbx_viewNote.setVisible(0);
			mlbx_viewLtr.setVisible(0);
			mlbx_viewCard.setVisible(0);
			mlbx_viewPckg.setVisible(0);
			
			canvas.popDialog(mlbx_GUI);
			commandToServer('mlbx_Request',"clearFields","");
		
		
		case "resetDpBxList":
			mlbx_DpBxDestMenu.clear();
			
			
		case "addToDpBxList":
			mlbx_DpBxDestMenu.add(%data,0);
		
		
		//////////////////////////////////////////////////
		
		
		case "verCheck":
			commandToServer('mlbx_Request',"verSetup","2");
		
		
		case "addPckgItem":
			mlbx_pckgItem.add(%data @ " - " @ %data.uiName,%n);
		
		
		case "addMail":
			mlbx_addMailRow(%n,%data);
		
		
		case "clearMail":
			mlbx_mailListBG.rowCount = 0;
			mlbx_mailListBG.clear();
		
		
		case "rmvMailRow":
			%rowRmvd = false;
			%rowCount = mClamp(mlbx_mailListBG.rowCount,0,50);
			
			for(%c = 0; %c < %rowCount; %c++)
			{
				if(isObject(%sw = "mailRow" @ %c))
				{
					%bmp = "mlbx_mailInv_img" @ %c;
					%new = "mlbx_mailInv_new" @ %c;
					%type = "mlbx_mailInv_type" @ %c;
					%sndr = "mlbx_mailInv_sndr" @ %c;
					%rcvd = "mlbx_mailInv_rcvd" @ %c;
					%del = "mlbx_mailInv_btnDel" @ %c;
					%view = "mlbx_mailInv_btnView" @ %c;
					
					if(%c == %n)
					{
						%sw.delete();
						%rowRmvd = true;
					}
					else if(%rowRmvd)
					{
						%cNew = %c - 1;
						
						if((mFloor(%cNew / 2) * 2) != %cNew)
							%sw.color = "210 210 210 150";
						else
							%sw.color = "255 255 255 150";
						
						%sw.position = 0 SPC %cNew * 24;
						%del.command = "commandToServer(\'mlbx_Request\',\"deleteMail\"," @ %cNew @ ");";
						%view.command = "mlbx_mailInv_new" @ %cNew @ ".setVisible(0);commandToServer(\'mlbx_Request\',\"viewMail\"," @ %cNew @ ");";
						
						%sw.setName("mailRow" @ %cNew);
						%bmp.setName("mlbx_mailInv_img" @ %cNew);
						%new.setName("mlbx_mailInv_new" @ %cNew);
						%type.setName("mlbx_mailInv_type" @ %cNew);
						%sndr.setName("mlbx_mailInv_sndr" @ %cNew);
						%rcvd.setName("mlbx_mailInv_rcvd" @ %cNew);
						%del.setName("mlbx_mailInv_btnDel" @ %cNew);
						%view .setName("mlbx_mailInv_btnView" @ %cNew);
					}
				}
			}
			if(%rowRmvd)
			{
				mlbx_mailListBG.rowCount = mClamp(mlbx_mailListBG.rowCount--,0,50);
				mlbx_mailListBG.resize(1,1,546,mClamp(mlbx_mailListBG.rowCount * 24,24,1200));
			}
		
		
		case "openMail":
			mlbx_mlbxInv.setVisible(1);
			canvas.pushDialog(mlbx_GUI);
		
		
		case "blockData":
			mlbx_mailDisab.setValue(getField(%data,0));
			
			if(!getField(%data,1))
			{
				mlbx_enabWhtList.setValue(0);
				mlbx_enabBlkList.setValue(1);
			}
			else
			{
				mlbx_enabWhtList.setValue(1);
				mlbx_enabBlkList.setValue(0);
			}
		
		
		case "blockListAdd":
			if(mlbx_blockList.rowCount() < 50)
			{
				if(%n == 0)
				{
					mlbx_blockList.clear();
					mlbx_blockList.sortNumerical(0,1); //prep for new values
				}
				
				%bl_id = getField(%data,0);
				mlbx_blockList.addRow(%bl_id,%data,%bl_id);
			}
			
		
		//////////////////////////////////////////////////
		
		
		case "viewNote":
			mlbx_noteViewText.setText(%data);
			mlbx_viewNote.setVisible(1);
			%new = "mlbx_mailInv_new" @ %n;
			%new.setVisible(0);
		
		
		case "viewLetterInit":
			mlbx_ltrViewText.setText("");
			mlbx_viewLtr.setVisible(1);
			mlbx_viewLtrScroll.scrollToTop();
			%new = "mlbx_mailInv_new" @ %n;
			%new.setVisible(0);
		
		
		case "viewLetterRcv":	
			mlbx_ltrViewText.setText(mlbx_ltrViewText.getText() @ %data);
		
		
		case "viewCard":
			mlbx_cardViewImg.setBitmap("Add-Ons/System_Mail/GUI/Cards/card" @ mClamp(%data,0,54));
			mlbx_viewCard.setVisible(1);
			%new = "mlbx_mailInv_new" @ %n;
			%new.setVisible(0);
	
	
		case "viewPackage" or "viewPckgRmv":
			if(isObject(%itemID = %data))
			{
				if(%itemID.iconName $= "")
				{
					%lRef = getSubStr(%itemID.uiName,0,1);
					mlbx_pckgImgView.setBitmap("Add-Ons/Print_Letters_Default/icons/" @ %lRef);
				}
				else
					mlbx_pckgImgView.setBitmap(%itemID.iconName);
				
				if(%itemID.doColorShift)
					mlbx_pckgImgView.mColor = getColorI(%itemID.colorShiftColor);
				else
					mlbx_pckgImgView.mColor = "255 255 255 255";
			}
			else
				mlbx_pckgImgView.setBitmap("Add-Ons/System_Mail/GUI/Images/noitem");
			
			if(%action !$= "viewPckgRmv" && %itemID > 0)
				mlbx_pckgViewTxt.setText("<font:impact:16><just:center><color:ffffff>You received a \"" @ %itemID.uiName @ "\"");
			else
				mlbx_pckgViewTxt.setText("<font:impact:16><just:center><color:ffffff>No item found in package.");
		
			mlbx_viewPckg.setVisible(1);
			mlbx_viewPckg.arrNum = %n;
			%new = "mlbx_mailInv_new" @ %n;
			%new.setVisible(0);
	}
}


////////////////////////////////////////////////////////////////////////////////////////////////////


function mlbx_GUIFuncs(%action)
{
	switch$(%action)
	{
		case "tabMail":
			mlbx_mailInvTab.setBitmap("Add-Ons/System_Mail/GUI/Images/TabUse"); //"base/client/ui/tab1use"
			mlbx_blockingTab.setBitmap("base/client/ui/tab1");
			
			mlbx_mailWndw.setVisible(1);
			mlbx_blockWndw.setVisible(0);
		
		
		case "tabBlock":
			mlbx_mailInvTab.setBitmap("base/client/ui/tab1");
			mlbx_blockingTab.setBitmap("Add-Ons/System_Mail/GUI/Images/TabUse");
			
			mlbx_mailWndw.setVisible(0);
			mlbx_blockWndw.setVisible(1);
			
			if(!mlbx_mlbxInv.blockListLoaded)
			{
				commandToServer('mlbx_Request',"sendBlockList","");
				mlbx_mlbxInv.blockListLoaded = true;
			}
		
		
		//////////////////////////////////////////////////
		
		
		case "pckgSelect":
			if(isObject(%itemID = firstWord(mlbx_pckgItem.getValue())))
			{
				if(%itemID.iconName $= "")
				{
					%lRef = getSubStr(%itemID.uiName,0,1);
					mlbx_pckgImg.setBitmap("Add-Ons/Print_Letters_Default/icons/" @ %lRef);
				}
				else
					mlbx_pckgImg.setBitmap(%itemID.iconName);
				
				if(%itemID.doColorShift)
					mlbx_pckgImg.mColor = getColorI(%itemID.colorShiftColor);
				else
					mlbx_pckgImg.mColor = "255 255 255 255";
			}
			else
				mlbx_pckgImg.setBitmap("Add-Ons/System_Mail/GUI/Images/noitem");
		
		
		case "cardSelect":
			%cardID = mlbx_cardType.getSelected(); //cards handled as IDs
			mlbx_cardImg.setBitmap("Add-Ons/System_Mail/GUI/Cards/card" @ %cardID);
		
		
		//////////////////////////////////////////////////

		
		case "sendNote":
			%txt = mlbx_noteText.getText();
			%str = getSubStr(%txt,0,255);
			
			if(strReplace(strReplace(%txt,"<font:impact:24>","")," ","") $= "" || %txt $= "<font:impact:24>text...")
			{
				CLIENTCMDmessageboxOK("Mailbox | Error","Invalid mail data; please type a message to send.");
				return;
			}			
			commandToServer('mlbx_setMailSrvr',"note","",%str);
		
		
		case "sendLtr":
			%txt = mlbx_ltrText.getText();
			%arrNum = 0;
			
			if(strReplace(strReplace(%txt,"<font:impact:20>","")," ","") $= "" || %txt $= "<font:impact:20>text...")
			{
				CLIENTCMDmessageboxOK("Mailbox | Error","Invalid mail data; please type a message to send.");
				return;
			}
			for(%n = 0; %n < 1785; %n += 255)
			{
				%str = getSubStr(%txt,%n,255);
				commandToServer('mlbx_setMailSrvr',"ltr",%arrNum,%str);
				%arrNum++;
			}
		
		
		case "sendCard":
			%cardID = mlbx_cardType.getSelected();
			commandToServer('mlbx_setMailSrvr',"card","",%cardID);
		
		
		case "sendPckg":
			%invNum = mlbx_pckgItem.getSelected();
			%itemID = firstWord(mlbx_pckgItem.getValue());
			commandToServer('mlbx_setMailSrvr',"pckg",%invNum,%itemID);
		
		
		case "DpBxSendName":
			if((%name = mlbx_DpBxDestMenu.getText()) $= "(Choose Mail Brick Destination)")
			{
				CLIENTCMDmessageboxOK("Mailbox | Invalid Name","Invalid brick name; please choose the name of a mail brick for the destination.");
				return;
			}

			commandToServer('mlbx_Request',"DpBxCheck",%name);
		
		
		//////////////////////////////////////////////////
		
		
		case "addToBlockList":
			%bl_id = mFloor(strReplace(mlbx_listPlyrID.getValue()," ",""));
			
			if(%bl_id !$= "")
			{
				if(mlbx_blockList.rowCount() >= 50)
					CLIENTCMDmessageboxOK("Mailbox | List Full","Block list is limited to 50 rows; no more players can be added.");
				else
				{
					mlbx_blockList.addRow(%bl_id,%bl_id TAB mlbx_listPlyrName.getValue(),%bl_id); //mAbs(mFloor(%bl_id))
					mlbx_blockList.sortNumerical(0,1);
				}
			}
			else
				CLIENTCMDmessageboxOK("Mailbox | Invalid Data","Text field for player ID is empty; please enter an ID to add.");
		
		
		case "rmvFromBlockList":
			if((%row = mlbx_blockList.getSelectedID()) > -1)
				mlbx_blockList.removeRowByID(%row);
		
		
		case "saveBlockList":
			commandToServer('mlbx_Request',"clearSrvrBlockList","");
			%count = mClamp(mlbx_blockList.rowCount(),0,50);
			
			for(%n = 0; %n < %count; %n++)
			{
				%plyrData = mlbx_blockList.getRowText(%n);
				commandToServer('mlbx_Request',"addSrvrBlockList",%n TAB %plyrData);
			}
			commandToServer('mlbx_Request',"fnlSrvrBlockList","");
	}
}