package mlbxPackage_srvr
{
	function GameConnection::autoAdminCheck(%cl)
	{
		%parent = parent::autoAdminCheck(%cl);
		
		if(%cl.mlbx_ver $= "")
			commandToClient(%cl,'mlbx_GUIUpdate',"verCheck","","");
		
		return %parent;
	}
	
	
	//////////////////////////////////////////////////
	
	
	function fxDTSBrick::onActivate(%br,%pl,%cl,%pos,%dir)
	{
		%parent = parent::onActivate(%br,%pl,%cl,%pos,%dir);
		
		if(%br.getDataBlock().isMlbx) // || %br.isMlbx
			SERVERCMDmlbx_Request(%cl,"openMail",%br);
		
		return %parent;
	}
	
	
	//////////////////////////////////////////////////
	
	
	function fxDtsBrick::onPlant(%br)
	{
		%parent = Parent::onPlant(%br);

		//Add bricks to sim set group
		if(%br.getDataBlock().isMlbx)
		{
			%br.isMlbx = true;
			mlbx_mailboxBrs.add(%br);
		}
		
		return %parent;
	}
	
	
	//////////////////////////////////////////////////
	
	
	function fxDtsBrick::onLoadPlant(%br)
	{
		%parent = Parent::onLoadPlant(%br);
		%db = %br.getDataBlock();
		%defDB = %db.mlbx_defDB;
		
		if(%db.isMlbx)
		{
			//Add bricks to sim set group
			%br.isMlbx = true;
			mlbx_mailboxBrs.add(%br);
			
			//If brick datablock is saved as aux datablock, restore to default
			if(%defDB !$= "" && isObject(%defDB))
				%br.setDatablock(%defDB);
		}
		return %parent;
	}
	
	
	//////////////////////////////////////////////////
	
	
	//function onExit() //encase saving is added later on
	//{
	//	%parent = Parent::onExit();
	//	return %parent;
	//}
	
	
	//////////////////////////////////////////////////
	
	
	function onServerDestroyed() //also encase saving is added later on
	{
		%parent = Parent::onServerDestroyed();
		
		mlbx_mailboxBrs.delete();
		mlbx_BlackWhiteLists.delete();
		
		return %parent;
	}
};
activatePackage(mlbxPackage_srvr);